#include <stdio.h>

#include "memory.h"

void dumpstats() {
    int freeBytes = MemoryGetAvailableBytes();
    int largestFreeBlockBytes = MemoryGetLargestAvailableBlockBytes();
    printf("Free bytes: %7d, largest free block: %7d\n", freeBytes, largestFreeBlockBytes);
}

void* allocate_block(int length) {
    void* block = MemoryAllocate(length);
    printf("Allocating %d bytes, got address %p\n", length, block);

    return block;
}

void free_block(void *block) {
    int length = MemoryGetBlockSize(block);
    MemoryFree(block);
    printf("Freeing %p (%d bytes)\n", block);
}

int main() {
    dumpstats();

    void* block1 = allocate_block(1000);
    dumpstats();

    void* block2 = allocate_block(1000);
    dumpstats();

    free_block(block1);
    dumpstats();

    return 0;
}
